// USB DTV`[i[̊NX

#pragma once
#include <windows.h>

// fobOrh̃G[R[ho
#ifdef _DEBUG
#define DTV_CATCH_INT_ERROR_CODE(err_code) {char err_buf[255];wsprintf(err_buf,"%s() errcode=%d\n",__FUNCTION__,err_code);OutputDebugString(err_buf);}
#else
#define DTV_CATCH_INT_ERROR_CODE(err_code) {err_code=err_code;/*rhwarningp_~[*/}
#endif

#define DTV_EXTFUNC_NONE	0x00000000	// {@\̂
#define DTV_EXTFUNC_CHSEL	0x00000001	// ChI\(DTV_EXTFUNC_CHSTRƂ͔r)
#define DTV_EXTFUNC_CHSTR	0x00000002	// ChI𕶎őI\(DTV_EXTFUNC_CHSELƂ͔r)

typedef void (CALLBACK PF_DTVRECVDATACALLBACK)(BYTE *pRecvData,DWORD dwRecvSize,unsigned __int64 ui64TotalRecvSize,LPVOID lpContext);

struct DTV_UsbEndpointInfo
{
  // The fields of an EndPoint Descriptor
  UCHAR  DscLen;
  UCHAR  DscType;
  UCHAR  Address;
  UCHAR  Attributes;
  USHORT MaxPktSize;
  USHORT PktsPerFrame;
  UCHAR  Interval;

  // Other fields
  ULONG  TimeOut;
  ULONG  UsbdStatus;
  ULONG  NtStatus;
};

struct DTV_TransferInfo
{
	DWORD dwStartTick;
	DWORD dwSuccess;
	DWORD dwFail;
	unsigned __int64 ui64RecvTotal;
};

struct DTV_ThreadParam
{
	LPVOID	pClassPtr;
	HANDLE	hExitEvent;
	LPVOID	pData;
};

// NX
class CDTV_Base
{
public:
	CDTV_Base()
	{
		m_pCallbackFunc=NULL;
		m_pCallbackContext=NULL;
		m_iPriority_Request=m_iPriority_Responce=THREAD_PRIORITY_NORMAL;
		ZeroMemory(&m_stThread,sizeof(struct DTV_CurrentThread));
		ClearTransferInfo();
	}
	virtual ~CDTV_Base()
	{
	}
	void ClearTransferInfo()
	{
		ZeroMemory(&m_stTransferInfo,sizeof(struct DTV_TransferInfo));
		m_stTransferInfo.dwStartTick=GetTickCount();
	}
	void GetTransferInfo(struct DTV_TransferInfo *pstInfo)
	{
		memcpy(pstInfo,&m_stTransferInfo,sizeof(struct DTV_TransferInfo));
	}
	void SetCallbackFunc(PF_DTVRECVDATACALLBACK lpFunc,LPVOID lpContext)
	{
		m_pCallbackFunc=lpFunc;
		m_pCallbackContext=lpContext;
	}
	void SetThreadPriority(int iRequest=THREAD_PRIORITY_NORMAL,int iResponce=THREAD_PRIORITY_NORMAL)
	{
		m_iPriority_Request=iRequest;
		m_iPriority_Responce=iResponce;
		if(m_stThread.stRequest.hThread != INVALID_HANDLE_VALUE)
		{
			::SetThreadPriority(m_stThread.stRequest.hThread,m_iPriority_Request);
		}
		if(m_stThread.stResponce.hThread != INVALID_HANDLE_VALUE)
		{
			::SetThreadPriority(m_stThread.stResponce.hThread,m_iPriority_Responce);
		}
	}

	virtual BOOL Initialize(char *szInitString,HWND hWnd,GUID *pGuid)=0;
	virtual void Release()=0;
	virtual BOOL IsInitialized()=0;

	virtual DWORD GetExtFunction()=0;
	virtual DWORD GetDeviceCount()=0;
	virtual BOOL GetDeviceName(int iDevNo,char *lpszDevName,int iBufLen)=0;
	virtual DWORD GetUsbEndpointCount(int iDevNo)=0;
	virtual BOOL GetUsbEndpointInfo(int iDevNo,int iUsbEpNo,struct DTV_UsbEndpointInfo *pUsbEpInfo)=0;
	virtual BOOL IsEndpointEffective(int iDevNo,int iUsbEpAddr)=0;

	// ڑ̂́
	virtual BOOL Connect(int iDevNo,int iInEpAddr,int iOutEpAddr)=0;
	virtual void DisConnect()=0;
	virtual BOOL IsConnect()=0;
	virtual void GetDeviceInfoText(char *lpszText,int iBufSize)
	{
		*lpszText='\0';
	}

	// `lgȂ
	// `l擾
	virtual DWORD GetChannelCount()
	{
		return 0;
	}
	// `l擾(߂l-1,0ŖAPȏ̔ԍLAȊO̓`lݒɎg)
	virtual int GetChannelName(int iChIndex,char *lpszChName,int iBufSize)
	{
		return -1;
	}
	// `lݒ(wlGetChannelName()̖߂l)
	virtual BOOL SetChannel(int iCh)
	{
		return FALSE;
	}
	// ݂̃`lԍ̎擾(߂l-1Ŗ)
	virtual int GetChannel()
	{
		return -1;
	}
	// `lݒ()
	// ( "B-181" : BS181 Ɖ߂͋@ɑMA͋@푤̐݌vɂBRAGPIO䓙ŝz )
	virtual BOOL SetChannnelByString(char *lpszChStr)
	{
		return FALSE;
	}

protected:
	// XbhgȂ
	virtual DWORD XferRequestProc(struct DTV_ThreadParam *lpParameter)
	{
		return 0;
	}
	virtual DWORD XferResponceProc(struct DTV_ThreadParam *lpParameter)
	{
		return 0;
	}

protected:
	PF_DTVRECVDATACALLBACK *m_pCallbackFunc;
	LPVOID m_pCallbackContext;
	int m_iPriority_Request;
	int m_iPriority_Responce;

	struct DTV_Thread
	{
		HANDLE hThread;
		DWORD dwThreadID;
	};
	struct DTV_CurrentThread
	{
		HANDLE hExitEvent;
		struct DTV_Thread stRequest;
		struct DTV_Thread stResponce;
	} m_stThread;
	struct DTV_TransferInfo m_stTransferInfo;
	// XbhJnGg
	static DWORD WINAPI XferRequestThreadEntry(LPVOID lpParameter)
	{
		struct DTV_ThreadParam *pParam=(struct DTV_ThreadParam*)lpParameter;
		CDTV_Base *pThis=(CDTV_Base*)pParam->pClassPtr;
		::SetThreadPriority(pThis->m_stThread.stRequest.hThread,pThis->m_iPriority_Request);
		return pThis->XferRequestProc(pParam);
	}
	static DWORD WINAPI XferResponceThreadEntry(LPVOID lpParameter)
	{
		struct DTV_ThreadParam *pParam=(struct DTV_ThreadParam*)lpParameter;
		CDTV_Base *pThis=(CDTV_Base*)pParam->pClassPtr;
		::SetThreadPriority(pThis->m_stThread.stResponce.hThread,pThis->m_iPriority_Responce);
		return pThis->XferResponceProc(pParam);
	}
	void DoDTVDataCallback(BYTE *pRecvData,DWORD dwRecvSize,unsigned __int64 ui64TotalRecvSize)
	{
		if(m_pCallbackFunc)	m_pCallbackFunc(pRecvData,dwRecvSize,ui64TotalRecvSize,m_pCallbackContext);
	}
};

// Critical Section Lapper
class CDTV_CriticalSection
{
public:
	CDTV_CriticalSection(CRITICAL_SECTION *lpCriticalSectionObject=NULL)
	{
		m_pCriticalSection=lpCriticalSectionObject;
		if(m_pCriticalSection) EnterCriticalSection(m_pCriticalSection);
	}
	~CDTV_CriticalSection()
	{
		if(m_pCriticalSection) LeaveCriticalSection(m_pCriticalSection);
	}

	static void InitializeCriticalSection(CRITICAL_SECTION *lpCriticalSectionObject)
	{
		::InitializeCriticalSection(lpCriticalSectionObject);
	}
	static void DeleteCriticalSection(CRITICAL_SECTION *lpCriticalSectionObject)
	{
		::DeleteCriticalSection(lpCriticalSectionObject);
	}

private:
	CRITICAL_SECTION *m_pCriticalSection;
};