#include "stdafx.h"
#include "EpgView.h"
#include "resource.h"
#include "commctrl.h"

CEpgView::CEpgView(void)
{
	m_hWnd = NULL;
	m_wServiceID = 0;
	m_pstProg = NULL;
	m_iNum = 0;
}

CEpgView::~CEpgView(void)
{
}

INT_PTR CEpgView::ShowModal(HINSTANCE hInst,int iResource,HWND hParentWnd)
{
	return DialogBoxParam(hInst,MAKEINTRESOURCE(iResource),hParentWnd,(DLGPROC)_EpgDlg,(LPARAM)this);
}

// tB^p_CAO
LRESULT CEpgView::EpgDlg(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	CEpgView* pThis=this;

	switch (message)
	{
	case WM_INITDIALOG:
		{
			m_hWnd=hDlg;
			OnInitDialog();
			return TRUE;
		}
		break;
	case WM_DRAWITEM:
		{
			UINT uID = (UINT)wParam;
			if(uID==IDC_EPG_LIST)
			{
				LPDRAWITEMSTRUCT lpDraw = (LPDRAWITEMSTRUCT)lParam;
				if(lpDraw->CtlType==ODT_LISTBOX)
				{
					if(lpDraw->itemID<m_ItemStrings.size())
					{
						std::string str = m_ItemStrings[lpDraw->itemID];
						BYTE byWeekday = (BYTE)HIWORD(lpDraw->itemData);
						COLORREF old_color;
						HGDIOBJ old_brush,old_pen;
						if(lpDraw->itemState&ODS_SELECTED)
						{
							old_color=SetTextColor(lpDraw->hDC,m_TextColor[0]);
							old_brush=SelectObject(lpDraw->hDC,m_BackBrush[0]);
						} else {
							if(lpDraw->itemID&1)
							{
								old_color=SetTextColor(lpDraw->hDC,m_TextColor[byWeekday+1]);
								old_brush=SelectObject(lpDraw->hDC,m_BackBrush[byWeekday+1]);
							} else {
								old_color=SetTextColor(lpDraw->hDC,m_TextColor[byWeekday+8]);
								old_brush=SelectObject(lpDraw->hDC,m_BackBrush[byWeekday+8]);
							}
						}
						old_pen=SelectObject(lpDraw->hDC,GetStockObject(NULL_PEN));
						int old_bk_mode=SetBkMode(lpDraw->hDC,TRANSPARENT);
						// `
						Rectangle(lpDraw->hDC,lpDraw->rcItem.left,lpDraw->rcItem.top,lpDraw->rcItem.right,lpDraw->rcItem.bottom);
						DrawText(lpDraw->hDC,str.c_str(),(int)str.length(),&lpDraw->rcItem,DT_NOPREFIX|DT_END_ELLIPSIS|DT_SINGLELINE|DT_VCENTER);
						// 
						SetTextColor(lpDraw->hDC,old_color);
						SelectObject(lpDraw->hDC,old_brush);
						SelectObject(lpDraw->hDC,old_pen);
						SetBkMode(lpDraw->hDC,old_bk_mode);
					}
				}
			}
		}
		break;
	case WM_COMMAND:
		{
			switch(LOWORD(wParam))
			{
			case IDCANCEL:
				{
					EndDialog(hDlg,(INT_PTR)-1);
				}
				break;
			case IDC_SCHEDULE:
				{
					LRESULT sel = SendDlgItemMessage(hDlg,IDC_EPG_LIST,LB_GETCURSEL,0,0);
					if(sel==LB_ERR) break;
					sel = SendDlgItemMessage(hDlg,IDC_EPG_LIST,LB_GETITEMDATA,sel,0);
					if(sel==LB_ERR) break;
					// IuWFNgj
					for(int weekday=0;weekday<7;weekday++)
					{
						DeleteObject(m_BackBrush[weekday]);
					}
					m_TextColor.clear();
					m_BackBrush.clear();
					EndDialog(hDlg,(INT_PTR)LOWORD(sel));
				}
				break;
			}
		}
		break;
	}
	return FALSE;
}

void CEpgView::OnInitDialog()
{
	SendDlgItemMessage(m_hWnd,IDC_EPG_LIST,LB_RESETCONTENT,0,0);

	if(!m_pstProg || m_iNum==0 )
	{
		EnableWindow(GetDlgItem(m_hWnd,IDC_EPG_LIST),FALSE);
		return;
	}
	int i;
	m_ItemStrings.clear();	
	for(i=0;i<m_iNum;i++)
	{
		char buf[300];
		long year,month,day,hour,min,sec;
		int pos=0;

		pos+=wsprintf(buf+pos,"[%s:%d:%02X] ",m_pstProg[i].byType < 2 ? "p/f" : "sch",m_pstProg[i].byType,m_pstProg[i].byVersion);

		CDateTime::ConvertFrom_MJD(m_pstProg[i].stStart.Date,year,month,day);
		CDateTime::ConvertFrom_TimeSec(m_pstProg[i].stStart.Time,hour,min,sec);
		if(m_pstProg[i].stStart.Time==TimeVal_Unknown)
		{
//			continue;
			pos+=wsprintf(buf+pos,"????/??/??(??) s - ");
		} else {
			pos+=wsprintf(buf+pos,"%04d/%02d/%02d(%s) %02d:%02d-",year,month,day,CDateTime::GetWeekDayString(m_pstProg[i].stStart.Date),hour,min);
			if(m_pstProg[i].dwDuration!=TimeVal_Unknown)
			{
				CDateTime::ConvertFrom_TimeSec(m_pstProg[i].stEnd.Time,hour,min,sec);
				pos+=wsprintf(buf+pos,"%02d:%02d",hour,min);
			} else {
				pos+=wsprintf(buf+pos," ",hour,min);
			}
		}
		pos+=wsprintf(buf+pos," [0x%04X] %s",m_pstProg[i].wEventID,m_pstProg[i].szTitle);
		LRESULT res=SendDlgItemMessage(m_hWnd,IDC_EPG_LIST,LB_ADDSTRING,0,(LPARAM)buf);
		m_ItemStrings.push_back(buf);
		SendDlgItemMessage(m_hWnd,IDC_EPG_LIST,LB_SETITEMDATA,res,MAKELPARAM(i,CDateTime::GetWeekDayVal(m_pstProg[i].stStart.Date)));
	}

	m_TextColor.clear();
	m_BackBrush.clear();
	// Weekday 0=I 1-7(~ẙ) 8-14(~y̋)
	COLORREF TextColor[15] = {
		RGB(255,255,255),
		RGB(  0,  0,  0),RGB(  0,  0,  0),RGB(  0,  0,  0),RGB(  0,  0,  0),RGB(  0,  0,  0),RGB(  0,  0,  0),RGB(  0,  0,  0),
		RGB(  0,  0,  0),RGB(  0,  0,  0),RGB(  0,  0,  0),RGB(  0,  0,  0),RGB(  0,  0,  0),RGB(  0,  0,  0),RGB(  0,  0,  0)
	};
	COLORREF BackColor[15] = {
		RGB(  0,  0,255),
		RGB(255,200,200),RGB(255,255,200),RGB(200,255,200),RGB(255,255,200),RGB(200,255,200),RGB(255,255,200),RGB(200,200,255),
		RGB(245,200,200),RGB(245,245,200),RGB(200,245,200),RGB(245,245,200),RGB(200,245,200),RGB(245,245,200),RGB(200,200,245),
	};
	for(int weekday=0;weekday<15;weekday++)
	{
		HBRUSH hBrush = CreateSolidBrush(BackColor[weekday]);
		m_BackBrush.push_back(hBrush);
		m_TextColor.push_back(TextColor[weekday]);
	}
}