#include "stdafx.h"
#include <shlwapi.h>
#include "Capusb_Main.h"
#include "ScheduleRec.h"
#include "TsStreamEngine/TsStream.h"
#include "resource.h"
#include <math.h>
#include <set>

CScheduleRec::CScheduleRec(CDTV_Base *pDTV)
{
	m_pDTV=pDTV;
	m_hWnd=NULL;
	m_hEditWnd=NULL;

	m_lpSetFilterFunc=NULL;
	m_lpSetFilterContext=NULL;

	m_lpEpgRequestFunc = NULL;
	m_lpEpgRequestContext = NULL;

	m_bCurrentProgram_EndTime_Unknown = FALSE;

	m_szSaveFile[0]=m_szPath[0]='\0';

	m_bScheduleRecording = FALSE;
	m_pScheduleRecord=NULL;
	m_iScheduleListMode = IDC_REC_SCHEDULE;

	m_wCurrentNetworkID = 0;
	m_wCurrentStreamID = 0;	
	m_stCurrentDateTime.Date=0;
	m_stCurrentDateTime.Time=0;	

#ifdef SCHEDULE_ENABLE_TIPWND
	m_hTip=NULL;
#endif

	CLock::CreateLockObj(&m_stLock);
}

CScheduleRec::~CScheduleRec(void)
{
	if(m_pScheduleRecord)
	{
		delete m_pScheduleRecord;
	}
	CLock::DestroyLockObj(&m_stLock);
}

BOOL CScheduleRec::Create(HINSTANCE hInst,int iResource,HWND hParentWnd,BOOL bNoPosSize,int x,int y,int sx,int sy,int iShowMode)
{
	m_hInst=hInst;
	m_hWnd=CreateDialogParam(hInst,MAKEINTRESOURCE(iResource),hParentWnd,(DLGPROC)_ScheduleDlg,(LPARAM)this);
	if(!bNoPosSize)
	{
		SetWindowPos(m_hWnd,0,x,y,sx,sy,SWP_NOZORDER);
	}
	ShowWindow(iShowMode);
	return TRUE;
}

void CScheduleRec::Destroy(int *pX ,int *pY,int *pSX,int *pSY,BOOL *pbShow)
{
	if(m_hWnd)
	{
		RECT rcRect;
		GetWindowRect(m_hWnd,&rcRect);
		if(pbShow) *pbShow=IsWindowVisible();
		if(pX) *pX=rcRect.left;
		if(pY) *pY=rcRect.top;
		if(pSX) *pSX=rcRect.right-rcRect.left;
		if(pSY) *pSY=rcRect.bottom-rcRect.top;
		DestroyWindow(m_hWnd);
	}
}

// ^\p_CAO
LRESULT CScheduleRec::ScheduleDlg(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		{
			m_hWnd=hDlg;
			OnInitDialog();
			return TRUE;
		}
		break;
	case WM_DESTROY:
		{
#ifdef SCHEDULE_ENABLE_TIPWND
			if(m_hTip)
			{
				DestroyWindow(m_hTip);
				m_hTip=NULL;
			}
#endif
		}
		break;
	case WM_CLOSE:
		{
			ShowWindow(SW_HIDE);
		}
		break;

	case WM_SIZE:
		{
			OnSize();
		}
		break;
	
	case WM_COMMAND:
		{
			switch(LOWORD(wParam))
			{
			case IDC_REC_SCHEDULE:
				if(m_iScheduleListMode != IDC_REC_SCHEDULE)
				{
					// ^\Ƀ`FbN
					m_iScheduleListMode = IDC_REC_SCHEDULE;
					CheckRadioButton(m_hWnd,IDC_REC_SCHEDULE,IDC_REC_FINISH,m_iScheduleListMode);
					// GUIACe
					PostMessage(m_hWnd,WM_SCHEDULE_REDRAWITEM,0,0);
				}
				break;
			case IDC_REC_FINISH:
				if(m_iScheduleListMode != IDC_REC_FINISH)
				{
					// IXgɃ`FbN
					m_iScheduleListMode = IDC_REC_FINISH;
					CheckRadioButton(m_hWnd,IDC_REC_SCHEDULE,IDC_REC_FINISH,m_iScheduleListMode);
					// GUIACe
					PostMessage(m_hWnd,WM_SCHEDULE_REDRAWITEM,0,0);
				}
				break;
			case IDC_DEL_FINISH:
				{
					// IXg폜
					CLock lock(&m_stLock);
					m_RecordEndList.clear();
					// GUIACe
					PostMessage(m_hWnd,WM_SCHEDULE_REDRAWITEM,0,0);
				}
				break;
			case IDC_ADD:
				{
					// \ǉ
					if(OnScheduleAdd_ByDateTime())
					{
						SetScheduleItem(&m_stEditItem);
					}
				}
				break;
			case IDC_DEL:
				{
					// \폜
					HWND hListView=GetDlgItem(m_hWnd,IDC_SCHEDULE_LIST);
					int sel=ListView_GetNextItem(hListView,-1,LVNI_ALL|LVNI_SELECTED);
					if(sel==-1) break;
					if(IsRecording(sel))
					{						
					//	MessageBox(m_hWnd,"^撆̃ACe͍폜ł܂B","",MB_OK);
						// ^掞ԂOɂċ~
						m_pScheduleRecord->stItem.stTime.dwRecSec=0;
					} else {
						RemoveScheduleItem(SCHEDULE_FLAG_REC_DELETE,sel);
					}
				}
				break;
			case IDC_EDIT:
				{
					HWND hListView=GetDlgItem(m_hWnd,IDC_SCHEDULE_LIST);
					int sel=ListView_GetNextItem(hListView,-1,LVNI_ALL|LVNI_SELECTED);
					if(sel==-1) break;
					// ^撆
					if(IsRecording(sel))
					{
						MessageBox(m_hWnd,"^撆̃ACe͕ҏWł܂B","",MB_OK);
					} else {
						struct ScheduleRecItem stItem = m_ScheduleList[sel];
						if(OnScheduleEdit(stItem))
						{
							SetScheduleItem(&stItem,sel);
						}
					}
				}
				break;
			}
		}
		break;

	case WM_SCHEDULE_REDRAWITEM:
		{
			RedrawScheduleList();
		}
		break;

	case WM_SCHEDULE_PUT_TIME_AND_SEARCH:
		{
			DateTime stTime={static_cast<DWORD>(wParam),static_cast<DWORD>(lParam)};
			Schedule(stTime);
		}
		break;

	case WM_SCHEDULE_NOTIFYSCROLL:
	case WM_SCHEDULE_NOTIFYMOUSEWHEEL:
		{
#ifdef SCHEDULE_ENABLE_TIPWND
			UpdateToolTip(GetDlgItem(hDlg,IDC_SERVICE_LIST));
#endif
		}
	}
	return FALSE;
}

// Subclass
static LRESULT CALLBACK ListViewExProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
#pragma warning(disable: 4312)
	WNDPROC lpOrigProc=reinterpret_cast<WNDPROC>(GetWindowLongPtr(hWnd,GWL_USERDATA));
#pragma warning(default: 4312)
	switch(message)
	{
	case WM_VSCROLL:
		{
			PostMessage(GetParent(hWnd),WM_SCHEDULE_NOTIFYSCROLL,0,0);
		}
		break;
	case 0x020A:// WM_MOUSEWHEEL:
		{
			PostMessage(GetParent(hWnd),WM_SCHEDULE_NOTIFYMOUSEWHEEL,0,0);
		}
		break;
	}
	return CallWindowProc(lpOrigProc,hWnd,message,wParam,lParam);
}

void CScheduleRec::OnInitDialog()
{	
	HWND hListView=GetDlgItem(m_hWnd,IDC_SCHEDULE_LIST);
	DWORD dwStyle=ListView_GetExtendedListViewStyle(hListView);
	dwStyle |= LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES;
	ListView_SetExtendedListViewStyle(hListView,dwStyle);

	// TuNX(bZ[Wǉʒmp)
	LONG_PTR LongPtr=GetWindowLongPtr(hListView,GWL_WNDPROC);
#pragma warning(disable: 4244)
	SetWindowLongPtr(hListView,GWL_USERDATA,LongPtr);
	SetWindowLongPtr(hListView,GWL_WNDPROC,reinterpret_cast<LONG_PTR>(ListViewExProc));
#pragma warning(default: 4244)

	// ^O쐬
	LV_COLUMN stLVCol;
	memset(&stLVCol,0,sizeof(stLVCol));
	stLVCol.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
	stLVCol.fmt = LVCFMT_LEFT;

	stLVCol.cx = 100;
	stLVCol.iSubItem=SCHEDULE_TAB_TYPE;
	stLVCol.pszText="^Cv";					
	ListView_InsertColumn(hListView, stLVCol.iSubItem, &stLVCol);

	stLVCol.cx = 200;
	stLVCol.iSubItem=SCHEDULE_TAB_START_TIME;	
	stLVCol.pszText="Jn";					
	ListView_InsertColumn(hListView, stLVCol.iSubItem, &stLVCol);

	stLVCol.cx = 120;
	stLVCol.iSubItem=SCHEDULE_TAB_DURATION_TIME;	
	stLVCol.pszText="^掞";
	ListView_InsertColumn(hListView, stLVCol.iSubItem, &stLVCol);

	stLVCol.cx = 250;
	stLVCol.iSubItem=SCHEDULE_TAB_STRINGS;	
	stLVCol.pszText="ڍ";
	ListView_InsertColumn(hListView, stLVCol.iSubItem, &stLVCol);

	// ^\Ƀ`FbN
	m_iScheduleListMode = IDC_REC_SCHEDULE;
	CheckRadioButton(m_hWnd,IDC_REC_SCHEDULE,IDC_REC_FINISH,m_iScheduleListMode);

	// GUI
	PostMessage(m_hWnd,WM_SCHEDULE_REDRAWITEM,0,0);

#ifdef SCHEDULE_ENABLE_TIPWND
	m_hTip=CreateWindowEx(0,TOOLTIPS_CLASS,NULL,TTS_ALWAYSTIP|TTS_BALLOON,0,0,0,0,hListView,NULL,m_hInst,NULL);
	SendMessage(m_hTip,TTM_SETDELAYTIME,TTDT_AUTOPOP,MAKELPARAM(30000,0));	// 30sec\
	SendMessage(m_hTip,TTM_SETMAXTIPWIDTH,0,(LPARAM)SCHEDULE_TIP_WIDTH);
	SendMessage(m_hTip,TTM_SETTIPTEXTCOLOR,SCHEDULE_TIP_TEXTCOLOR,0);
	SendMessage(m_hTip,TTM_SETTIPBKCOLOR,SCHEDULE_TIP_BGCOLOR,0);
#endif
}

// EBhETCYύX
void CScheduleRec::OnSize()
{
	CLock lock(&m_stLock);
	// EBhETCYύXقACeǏ]
	RECT rcRect,rcItem;
	HWND hListView=GetDlgItem(m_hWnd,IDC_SCHEDULE_LIST);
	GetWindowRect(m_hWnd,&rcRect);
	GetWindowRect(hListView,&rcItem);
	int iMarginX=rcItem.left-rcRect.left;
	int iMarginY=rcItem.top-rcRect.top;					
	SetWindowPos(hListView,NULL,0,0,rcRect.right-rcRect.left-iMarginX*2,rcRect.bottom-rcRect.top-iMarginY-iMarginX,SWP_NOMOVE|SWP_NOZORDER);
#ifdef SCHEDULE_ENABLE_TIPWND
	UpdateToolTip(hListView);
#endif
}

static int stl_sort_func_cmp(struct ScheduleRecItem& a, struct ScheduleRecItem& b)
{
	if(a.dwFlg&SCHEDULE_FLAG_EVENTID && a.stTime.stStart.Date==0 && b.dwFlg&SCHEDULE_FLAG_EVENTID && b.stTime.stStart.Date==0)
	{
		// CxgwŎ擾
		if(a.stEvent.wServiceID==b.stEvent.wServiceID)
		{
			return a.stEvent.wEventID < b.stEvent.wEventID;
		} else {
			return a.stEvent.wServiceID < b.stEvent.wServiceID;
		}
	}
	else if(a.dwFlg&SCHEDULE_FLAG_EVENTID && a.stTime.stStart.Date==0)	
	{
		// â݃Cxg
		return 0;
	}
	else if(b.dwFlg&SCHEDULE_FLAG_EVENTID && b.stTime.stStart.Date==0)
	{
		// b̂݃Cxgw
		return 1;
	}
	else if(a.stTime.stStart.Date==b.stTime.stStart.Date)
	{
		// tȂJnŃ\[g
		return a.stTime.stStart.Time < b.stTime.stStart.Time;
	} else {
		// ႤtȂt傫ق
		return a.stTime.stStart.Date < b.stTime.stStart.Date;
	}
}

// \^掞ԂԂĂȂ̌(ŵ̂̂)
BOOL CScheduleRec::CheckScheduleTime(struct ScheduleRecItem *pstItem,int iIndex)
{
	if(pstItem->dwFlg&SCHEDULE_FLAG_DATETIME)
	{
		DateTime dtNewStart=pstItem->stTime.stStart;
		bool bCheck=false;
		for(unsigned int i=0;i<m_ScheduleList.size()&&!bCheck;i++)
		{
			// g̃CfbNX̓`FbNȂ
			if(i==iIndex) continue;
			// Ώۂw or Cxgw肩擾ς
			if(m_ScheduleList[i].dwFlg&SCHEDULE_FLAG_DATETIME||(m_ScheduleList[i].dwFlg&SCHEDULE_FLAG_EVENTID&&m_ScheduleList[i].stTime.stStart.Date!=0))
			{
				DateTime dtCheck=m_ScheduleList[i].stTime.stStart;				
				bCheck|=CDateTime::Check_Time(dtNewStart,0,dtNewStart,pstItem->stTime.dwRecSec,dtCheck,0);
				bCheck|=CDateTime::Check_Time(dtNewStart,0,dtNewStart,pstItem->stTime.dwRecSec,dtCheck,m_ScheduleList[i].stTime.dwRecSec);
			}
		}
		if(bCheck)
		{
			if(MessageBox(m_hWnd,"^\񎞊ԂdĂ܂B\nd\s܂H","^\",MB_YESNO)==IDNO)
			{
				return FALSE;
			}
		}
	}
	return TRUE;
}

// ^\ACeZbg
// iIndex=-1NewAȊOȂYACe̍XVƂ
BOOL CScheduleRec::SetScheduleItem(struct ScheduleRecItem *pstItem,int iIndex)
{
	CLock lock(&m_stLock);
	if(iIndex<-1) return FALSE;
	if(iIndex==-1)
	{
		// VKǉ
		if(!CheckScheduleTime(pstItem,iIndex)) return FALSE;
		m_ScheduleList.push_back(*pstItem);
	}
	else if((unsigned)iIndex<m_ScheduleList.size())
	{
		// XV
		if(!CheckScheduleTime(pstItem,iIndex)) return FALSE;
		m_ScheduleList[iIndex]=*pstItem;
	}
	else
	{
		// IndexG[
		return FALSE;
	}
	// \[g
	std::sort(m_ScheduleList.begin(),m_ScheduleList.end(),stl_sort_func_cmp);
	// GUIACe
	PostMessage(m_hWnd,WM_SCHEDULE_REDRAWITEM,0,0);
	return TRUE;
}

BOOL CScheduleRec::IsRecording(int iIndex)
{
	CLock lock(&m_stLock);
	if(iIndex<0||(unsigned)iIndex>=m_ScheduleList.size()) return FALSE;
	struct ScheduleRecItem stItem=m_ScheduleList[iIndex];
	// ^撆
	if(m_pScheduleRecord)
	{
		DWORD dwStatus=m_pScheduleRecord->stItem.dwFlg&SCHEDULE_FLAG_STATUSMASK;
		if(dwStatus==SCHEDULE_FLAG_RECORDING || dwStatus==SCHEDULE_FLAG_PRERECORD)
		{
			if(memcmp(&m_pScheduleRecord->stItem.stTime,&stItem.stTime,sizeof(stItem.stTime))==0)
			{
				// ^撆Ɣ
				return TRUE;
			}
		}
	}
	return FALSE;
}

// ^\ACe폜
// iStatusFlgSCHEDULE_FLAG_REC_DELETEłȂꍇA폜ACe͊Xgɒǉ
BOOL CScheduleRec::RemoveScheduleItem(int iStatusFlg,int iIndex)
{
	CLock lock(&m_stLock);
	if(iIndex<0||(unsigned)iIndex>=m_ScheduleList.size()) return FALSE;
	struct ScheduleRecItem stItem=m_ScheduleList[iIndex];
	// ^撆
	if(IsRecording(iIndex)) return FALSE;
	// tO𗧂Ă	
	stItem.dwFlg = (stItem.dwFlg & (SCHEDULE_FLAG_FULLBIT ^ SCHEDULE_FLAG_STATUSMASK)) | iStatusFlg;
	// Xg^Iɉ
	if(iStatusFlg!=SCHEDULE_FLAG_REC_DELETE)
	{
		m_RecordEndList.push_back(stItem);
	}
	// ^\񃊃Xg폜
	m_ScheduleList.erase(m_ScheduleList.begin()+iIndex);
	// ^TȂ玟ɒǉ
	if(stItem.dwFlg&SCHEDULE_FLAG_NEXTDAY)
	{
		stItem.dwFlg &= (SCHEDULE_FLAG_FULLBIT ^ SCHEDULE_FLAG_STATUSMASK);
		CDateTime::OffsetDateTime(stItem.stTime.stStart,TimeVal_OneDay);
		SetScheduleItem(&stItem);
	}
	else if(stItem.dwFlg&SCHEDULE_FLAG_NEXTWEEK)
	{
		stItem.dwFlg &= (SCHEDULE_FLAG_FULLBIT ^ SCHEDULE_FLAG_STATUSMASK);
		CDateTime::OffsetDateTime(stItem.stTime.stStart,TimeVal_OneDay*7);
		SetScheduleItem(&stItem);
	}
	// GUIACe
	PostMessage(m_hWnd,WM_SCHEDULE_REDRAWITEM,0,0);
	return TRUE;
}

void CScheduleRec::RedrawScheduleList()
{
	CLock lock(&m_stLock);
	char buf[MAX_PATH+100];
	HWND hListView=GetDlgItem(m_hWnd,IDC_SCHEDULE_LIST);	

	wsprintf(buf,"^\(%d)",m_ScheduleList.size());
	SetDlgItemText(m_hWnd,IDC_REC_SCHEDULE,buf);
	wsprintf(buf,"\I(%d)",m_RecordEndList.size());
	SetDlgItemText(m_hWnd,IDC_REC_FINISH,buf);

	ScheduleRecList &ShowList = m_iScheduleListMode==IDC_REC_SCHEDULE ? m_ScheduleList : m_RecordEndList;

	ListView_DeleteAllItems(hListView);
	unsigned int i,n;
	n=static_cast<unsigned int>(ShowList.size());
	for(i=0;i<n;i++)
	{
		struct ScheduleRecItem &stItem=ShowList[i];
		int pos;
		LV_ITEM stLI;		
		ZeroMemory(&stLI,sizeof(stLI));
		stLI.pszText=buf;
		stLI.mask=LVIF_PARAM|LVIF_TEXT;
		stLI.lParam= i;
		stLI.iItem = i;
		if(stItem.dwFlg&SCHEDULE_FLAG_DATETIME)
		{
			wsprintf(stLI.pszText,"t");
		}
		else if(stItem.dwFlg&SCHEDULE_FLAG_EVENTID)
		{
			wsprintf(stLI.pszText,"Cxg");
		}
		// Xe[^X
		if((stItem.dwFlg&SCHEDULE_FLAG_STATUSMASK)==SCHEDULE_FLAG_PRERECORD)
		{
			if(stItem.bNoRecord)
			{
				lstrcat(stLI.pszText,"[  ]");
			} else {
				lstrcat(stLI.pszText,"[ ^揀 ]");
			}
		}
		if((stItem.dwFlg&SCHEDULE_FLAG_STATUSMASK)==SCHEDULE_FLAG_RECORDING)
		{
			if(stItem.bNoRecord)
			{
				lstrcat(stLI.pszText,"[  ]");
			} else {
				lstrcat(stLI.pszText,"[ ^撆 ]");
			}
		}
		if((stItem.dwFlg&SCHEDULE_FLAG_STATUSMASK)==SCHEDULE_FLAG_REC_SUCCESS)
		{
			lstrcat(stLI.pszText,"[ I ]");
		}
		if((stItem.dwFlg&SCHEDULE_FLAG_STATUSMASK)==SCHEDULE_FLAG_REC_ERROR)
		{
			lstrcat(stLI.pszText,"[ G[ ]");
		}
		if((stItem.dwFlg&SCHEDULE_FLAG_STATUSMASK)==SCHEDULE_FLAG_REC_INVALID)
		{
			lstrcat(stLI.pszText,"[  ]");
		}
		if((stItem.dwFlg&SCHEDULE_FLAG_STATUSMASK)==SCHEDULE_FLAG_REC_CANCEL)
		{
			lstrcat(stLI.pszText,"[ LZ ]");
		}
		ListView_InsertItem(hListView,&stLI);

		// Sub Item
		long year,mon,day,hour,min,sec;
		stLI.mask=LVIF_TEXT;
		stLI.pszText=buf;
		// Jn
		stLI.iSubItem = 1;
		CDateTime::ConvertFrom_MJD(stItem.stTime.stStart.Date,year,mon,day);
		CDateTime::ConvertFrom_TimeSec(stItem.stTime.stStart.Time,hour,min,sec);
		if(stItem.stTime.stStart.Date>0)
		{
			wsprintf(stLI.pszText,"%04dN%02d%02d(%s) %02d%02d%02db",year,mon,day,CDateTime::GetWeekDayString(stItem.stTime.stStart.Date%7),hour,min,sec);
		} else {
			wsprintf(stLI.pszText,"s(ID=%04X:%04X:%04X:%04X)",stItem.stEvent.wNetworkID,stItem.stEvent.wStreamID,stItem.stEvent.wServiceID,stItem.stEvent.wEventID);
		}
		ListView_SetItem(hListView,&stLI);
		// ^掞
		stLI.iSubItem = 2;
		if(stItem.stTime.dwRecSec!=TimeVal_Unknown)
		{
			CDateTime::ConvertFrom_TimeSec(stItem.stTime.dwRecSec,hour,min,sec);
			if(stItem.stTime.stStart.Date>0)
			{
				wsprintf(stLI.pszText,"%02d  %02d  %02d b",hour,min,sec);
			} else {
				wsprintf(stLI.pszText,"s");
			}
		} else {
			wsprintf(stLI.pszText,"");
		}
		ListView_SetItem(hListView,&stLI);
		// ̑
		stLI.iSubItem = 3;
		pos=0;
		stLI.pszText[0]='\0';
		if(stItem.bNoRecord)
		{
			pos+=wsprintf(stLI.pszText+pos,"[̂]");
		}
		if(stItem.dwFlg&SCHEDULE_FLAG_NEXTDAY)
		{
			pos+=wsprintf(stLI.pszText+pos,"[]");
		}
		if(stItem.dwFlg&SCHEDULE_FLAG_NEXTWEEK)
		{
			pos+=wsprintf(stLI.pszText+pos,"[T]");
		}
		if(stItem.dwFlg&SCHEDULE_FLAG_CHANNEL)
		{
			pos+=wsprintf(stLI.pszText+pos,"[`lݒ=%d]",stItem.byChannel);
		}
		if(stItem.dwFlg&SCHEDULE_FLAG_CHANNEL_STR)
		{
			pos+=wsprintf(stLI.pszText+pos,"[`l=%s]",stItem.szChannnelStr);
		}
		if(stItem.dwFlg&SCHEDULE_FLAG_SERVICE_ID)
		{
			pos+=wsprintf(stLI.pszText+pos,"[T[rXID=%s]",stItem.szServiceID);
		}
		if(stItem.dwFlg&SCHEDULE_FLAG_USERFILENAME)
		{
			pos+=wsprintf(stLI.pszText+pos,"[t@Cw]");
		}
		if(stItem.dwFlg&SCHEDULE_FLAG_EVENTID)
		{
			if(stItem.stEvent.szEventName[0])
			{
				pos+=wsprintf(stLI.pszText+pos,"[%s]",stItem.stEvent.szEventName);
			}
		}
		ListView_SetItem(hListView,&stLI);
	}
}

// LXg\z
BOOL CScheduleRec::GetDisablePids(BOOL bDenyFlg,WORD *pwServices,int iNum,WORD** ppPidList,int *piNum)
{
	CLock lock(&m_stLock);
	if(!ppPidList || !piNum) return FALSE;

	ScheduleServices::iterator itService;
	SchedulePidItems::iterator itPid;
	std::set<WORD> Allow,Deny,List;
	std::set<WORD>::iterator it;
	int i;

#ifdef SCHEDULE_DEBUG_PRINT
	{
		OutputDebugString("-- Make Deny Pid --");
	}
#endif
	for(itService=m_CurrentService.begin();itService!=m_CurrentService.end();itService++)
	{
		BOOL bFind=FALSE;
		for(i=0;i<iNum&&bFind==FALSE;i++)
		{
			if(itService->first==pwServices[i])
			{
				bFind=TRUE;
			}
		}
		for(itPid=itService->second.begin();itPid!=itService->second.end();itPid++)
		{
			if(bDenyFlg)
			{
				if(bFind)
				{
					Deny.insert(itPid->wPID);
				} else {
					Allow.insert(itPid->wPID);
				}
			} else {
				if(bFind)
				{
					Allow.insert(itPid->wPID);
				} else {
					Deny.insert(itPid->wPID);
				}
			}
		}
	}
	for(it=Deny.begin();it!=Deny.end();it++)
	{
		if(Allow.find(*it)==Allow.end())
		{
			List.insert(*it);
		}
	}
	*piNum=static_cast<int>(List.size());
	*ppPidList = new WORD[*piNum];
	i=0;
	for(it=List.begin();it!=List.end();it++)
	{
		(*ppPidList)[i++]=*it;
#ifdef SCHEDULE_DEBUG_PRINT
		{
			char dbg_buf[20];
			wsprintf(dbg_buf,"DenyPID=%04X\n",*it);
			OutputDebugString(dbg_buf);
		}
#endif
	}
	return TRUE;
}

// ݂͕lĂȂ
void CScheduleRec::GetStatusString(char *lpszBuf,int iBufSize)
{
	CLock lock(&m_stLock);
	lpszBuf[0]='\0';
	if(m_pScheduleRecord)
	{
		if(m_bCurrentProgram_EndTime_Unknown)
		{
			wsprintf(lpszBuf,"Ïבҋ@");
		} else {
			char *pMode = "^";
			if(m_pScheduleRecord->stItem.bNoRecord) pMode = "";
			if((m_pScheduleRecord->stItem.dwFlg & SCHEDULE_FLAG_STATUSMASK) == SCHEDULE_FLAG_PRERECORD)
			{
				DateTimeVal64 dtVal=CDateTime::GetDateTimeValue(m_pScheduleRecord->stItem.stTime.stStart)-CDateTime::GetDateTimeValue(m_stCurrentDateTime) - SCHEDULE_MARGIN_SEC;
				if(dtVal>0)
				{
					wsprintf(lpszBuf,"\%s(Jn܂%02db)",pMode,dtVal);
				}
			}
			else if((m_pScheduleRecord->stItem.dwFlg & SCHEDULE_FLAG_STATUSMASK) == SCHEDULE_FLAG_RECORDING)
			{
				if(m_pScheduleRecord->pFileRecord)
				{
					ULARGE_INTEGER liFree=m_pScheduleRecord->pFileRecord->GetFreeSize();
					wsprintf(lpszBuf,"\^撆(%I64uMB c%I64u MB)",m_pScheduleRecord->pFileRecord->GetWriteTotalSize()/1024/1024,liFree.QuadPart/1024/1024);
				} else if(m_pScheduleRecord->stItem.bNoRecord) {
					wsprintf(lpszBuf,"\񎋒");
				}
			}
		}
	} else {
		if(m_ScheduleList.size()>0)
		{
			ScheduleRecItem &stItem=m_ScheduleList[0];
			if(m_stCurrentDateTime.Date>0)
			{
				if(stItem.dwFlg&SCHEDULE_FLAG_DATETIME || (stItem.dwFlg&SCHEDULE_FLAG_EVENTID && stItem.stTime.stStart.Date>0))
				{
					DateTimeVal64 dtVal=CDateTime::GetDateTimeValue(stItem.stTime.stStart)-CDateTime::GetDateTimeValue(m_stCurrentDateTime) - SCHEDULE_PREPROC_SEC;
					char *pMode = "^";
					if(stItem.bNoRecord) pMode = "";
					if(dtVal>0)
					{
						if(dtVal>=60)
						{
							if(dtVal<TimeVal_OneDay)
							{
								div_t min_sec=div(static_cast<int>(dtVal),60);
								if(min_sec.quot>=60)
								{
									div_t hour_min=div(static_cast<int>(min_sec.quot),60);
									wsprintf(lpszBuf,"%s܂ł %d:%02d:%02d",pMode,hour_min.quot,hour_min.rem,min_sec.rem);
								} else {
									wsprintf(lpszBuf,"%s܂ł%d:%02d",pMode,min_sec.quot,min_sec.rem);
								}
							} else {
								wsprintf(lpszBuf,"Pȓɗ\͂܂");
							}
						} else {
							wsprintf(lpszBuf,"%s܂ł%02db",pMode,dtVal);
						}
					}
				} else {
					wsprintf(lpszBuf,"Cxg擾҂");
				}
			}
		}
	}
}

#ifdef SCHEDULE_ENABLE_TIPWND
// c[Tipp̍XV
void CScheduleRec::UpdateToolTip(HWND hListView)
{
	CLock lock(&m_stLock);

	unsigned int iItemTop=ListView_GetTopIndex(hListView);
	unsigned int iItemInPageCount=ListView_GetCountPerPage(hListView);
	unsigned int iItemBottom=iItemTop+iItemInPageCount;

	unsigned int iItemCount=ListView_GetItemCount(hListView);
	if(iItemCount==0) return;

	// ő\ACeωA̕ǉ
	while(m_Tooltip.size()<iItemInPageCount)
	{
		SCHEDULE_TOOLTIP stNew;
		ZeroMemory(&stNew,sizeof(SCHEDULE_TOOLTIP));
		stNew.stToolTipInfo.cbSize=sizeof(SCHEDULE_TOOLTIP);
		stNew.stToolTipInfo.hwnd=hListView;
		stNew.stToolTipInfo.uFlags=TTF_SUBCLASS;
		stNew.stToolTipInfo.uId=m_Tooltip.size()+1;		
		stNew.stToolTipInfo.lpszText="";
		if(ListView_GetItemRect(hListView,0,&stNew.stToolTipInfo.rect,LVIR_BOUNDS))
		{
			unsigned int iHeight=stNew.stToolTipInfo.rect.bottom-stNew.stToolTipInfo.rect.top;
			unsigned int iTop = stNew.stToolTipInfo.rect.top;
			stNew.stToolTipInfo.rect.top    = stNew.stToolTipInfo.rect.top + iHeight * (stNew.stToolTipInfo.uId-1);
			stNew.stToolTipInfo.rect.bottom = stNew.stToolTipInfo.rect.top + iHeight;
			SendMessage(m_hTip,TTM_ADDTOOL,0,(LPARAM)&stNew.stToolTipInfo);			
		}
		m_Tooltip.push_back(stNew);
	}
	// ACeXV
	RECT rcItem;
	if(ListView_GetItemRect(hListView,0,&rcItem,LVIR_BOUNDS))
	{
		unsigned int i,n;
		n=static_cast<unsigned int>(m_Tooltip.size());		
		for(i=0;i<n;i++)
		{			
			TOOLINFO *pToolInfo=&m_Tooltip[i].stToolTipInfo;
			// XV
			pToolInfo->rect.left=rcItem.left;
			pToolInfo->rect.right=rcItem.right;
			SendMessage(m_hTip,TTM_NEWTOOLRECT,0,(LPARAM)pToolInfo);
			// eLXgXV
			char buf[SCHEDULE_TIP_MAX_STR]=SCHEDULE_TIP_NODATA;
			pToolInfo->lpszText=buf;
			if(iItemTop+i<iItemCount)
			{
			
			}
			SendMessage(m_hTip,TTM_UPDATETIPTEXT,0,(LPARAM)pToolInfo);
		}
	}
}
#endif


//////////////////////////////////////////////////////////////////////
//

void CScheduleRec::SetRecPath(char *lpszPath)
{
	lstrcpy(m_szPath,lpszPath);
}

// ^\񃊃Xgۑ
void CScheduleRec::SaveSchedule(char *lpszFile)
{
	CLock lock(&m_stLock);
	if(lpszFile)
	{
		lstrcpy(m_szSaveFile,lpszFile);
	}
	if(!m_szSaveFile[0]) return;

	FILE *fp;
	fopen_s(&fp,m_szSaveFile,"wt");
	if(!fp) return;
	unsigned int i,n;
	n=static_cast<unsigned int>(m_ScheduleList.size());
	fprintf(fp,"[CapUSB_Schedule]\n");
	fprintf(fp,"ScheduleNum=%d\n\n",n);
	for(i=0;i<n;i++)
	{
		long year,month,day,hour,min,sec;
		ScheduleRecItem &stItem=m_ScheduleList[i];
		fprintf(fp,"[Schedule_%d]\n",i+1);
		DWORD dwFlg = stItem.dwFlg & (SCHEDULE_FLAG_FULLBIT ^ SCHEDULE_FLAG_STATUSMASK);	/* Xe[^Xĕۑ */
		fprintf(fp,";0x%08X\n"			,dwFlg);
		fprintf(fp,"Flag=%d\n"			,dwFlg);
		//
		CDateTime::ConvertFrom_MJD(stItem.stTime.stStart.Date,year,month,day);
		CDateTime::ConvertFrom_TimeSec(stItem.stTime.stStart.Time,hour,min,sec);
/*		if(stItem.dwFlg&SCHEDULE_FLAG_EVENTID)
		{
			// CxgŵƂ́AۑȂ(`lύXɔۑ悤ɎbύX)
			fprintf(fp,";Start=%04d/%02d/%02d %02d:%02d\n"	,0,0,0,0,0);		
			fprintf(fp,"StartDateMJD=%d\n"	,0);
			fprintf(fp,"StartTimeSec=%d\n"	,0);
			fprintf(fp,";Rec=%02d:%02d:%2d\n",0,0,0);
			fprintf(fp,"RecordSec=%d\n"		,0);
		} else {*/
			fprintf(fp,";Start=%04d/%02d/%02d %02d:%02d\n"	,year,month,day,hour,min);		
			fprintf(fp,"StartDateMJD=%d\n"	,stItem.stTime.stStart.Date);
			fprintf(fp,"StartTimeSec=%d\n"	,stItem.stTime.stStart.Time);
			CDateTime::ConvertFrom_TimeSec(stItem.stTime.dwRecSec,hour,min,sec);
			fprintf(fp,";Rec=%02d:%02d:%2d\n",hour,min,sec);
			fprintf(fp,"RecordSec=%d\n"		,stItem.stTime.dwRecSec);
/*		} */
		//
		fprintf(fp,"NetworkID=%d\n"		,stItem.stEvent.wNetworkID);
		fprintf(fp,"StreamID=%d\n"		,stItem.stEvent.wStreamID);
		fprintf(fp,"ServiceID=%d\n"		,stItem.stEvent.wServiceID);
		fprintf(fp,"EventID=%d\n"		,stItem.stEvent.wEventID);
		fprintf(fp,"OffsetStart=%d\n"	,stItem.stEvent.iOffsetStart);
		fprintf(fp,"OffsetEnd=%d\n"		,stItem.stEvent.iOffsetEnd);
		//
		fprintf(fp,"NoRecord=%d\n"		,stItem.bNoRecord);
		fprintf(fp,"Dir=%s\n"			,stItem.szDir);
		fprintf(fp,"File=%s\n"			,stItem.szFile);
		fprintf(fp,"Ext=%s\n"			,stItem.szExt);
		fprintf(fp,"ChVal=%d\n"			,stItem.byChannel);
		fprintf(fp,"ChStr=%s\n"			,stItem.szChannnelStr);
		fprintf(fp,"EnableServiceID=%s\n"		,stItem.szServiceID);
		//
		fprintf(fp,"\n");
	}
	fclose(fp);
}

// ^\񃊃XgǍ
void CScheduleRec::LoadSchedule(char *lpszFile)
{
	CLock lock(&m_stLock);
	if(lpszFile)
	{
		lstrcpy(m_szSaveFile,lpszFile);
	}
	if(!m_szSaveFile[0]) return;

	m_ScheduleList.clear();
	if(GetFileAttributes(m_szSaveFile)==INVALID_FILE_ATTRIBUTES) return;

	int i,n;
	n=GetPrivateProfileInt("CapUSB_Schedule","ScheduleNum",0,m_szSaveFile);
	for(i=0;i<n;i++)
	{
		ScheduleRecItem stItem;
		ZeroMemory(&stItem,sizeof(stItem));
		char key[20];
		wsprintf(key,"Schedule_%d",i+1);
		//
		stItem.dwFlg=GetPrivateProfileInt(key,"Flag",0,m_szSaveFile);
		if(stItem.dwFlg==0) continue;
		//
		stItem.stTime.stStart.Date=GetPrivateProfileInt(key,"StartDateMJD",0,m_szSaveFile);
		stItem.stTime.stStart.Time=GetPrivateProfileInt(key,"StartTimeSec",0,m_szSaveFile);
		stItem.stTime.dwRecSec=GetPrivateProfileInt(key,"RecordSec",0,m_szSaveFile);
		//
		stItem.stEvent.wNetworkID=GetPrivateProfileInt(key,"NetworkID",0,m_szSaveFile);
		stItem.stEvent.wStreamID=GetPrivateProfileInt(key,"StreamID",0,m_szSaveFile);
		stItem.stEvent.wServiceID=GetPrivateProfileInt(key,"ServiceID",0,m_szSaveFile);
		stItem.stEvent.wEventID=GetPrivateProfileInt(key,"EventID",0,m_szSaveFile);
		stItem.stEvent.iOffsetStart=GetPrivateProfileInt(key,"OffsetStart",0,m_szSaveFile);
		stItem.stEvent.iOffsetEnd=GetPrivateProfileInt(key,"OffsetEnd",0,m_szSaveFile);
		//
		stItem.bNoRecord=(BYTE)GetPrivateProfileInt(key,"NoRecord",0,m_szSaveFile);
		GetPrivateProfileString(key,"Dir","",stItem.szDir,MAX_PATH,m_szSaveFile);
		GetPrivateProfileString(key,"File","",stItem.szFile,MAX_PATH,m_szSaveFile);
		GetPrivateProfileString(key,"Ext","",stItem.szExt,MAX_PATH,m_szSaveFile);
		stItem.byChannel=(BYTE)GetPrivateProfileInt(key,"ChVal",0,m_szSaveFile);
		GetPrivateProfileString(key,"ChStr","",stItem.szChannnelStr,80,m_szSaveFile);
		GetPrivateProfileString(key,"EnableServiceID","",stItem.szServiceID,100,m_szSaveFile);

//		SetScheduleItem(&stItem);
		m_ScheduleList.push_back(stItem);
	}
	// \[g
	std::sort(m_ScheduleList.begin(),m_ScheduleList.end(),stl_sort_func_cmp);
	
}

// ݂̃Xg[ID󂯎(Xg[~^IDύX)
void CScheduleRec::PutStreamID(WORD wStreamID)
{
	m_wCurrentStreamID = wStreamID;
	m_CurrentService.clear();
}

// ݂̃lbg[NID󂯎
void CScheduleRec::PutNetworkID(WORD wNetworkID)
{
	m_wCurrentNetworkID = wNetworkID;
}

// ݂PID󂯎
void CScheduleRec::PutPID(WORD wServiceID,SCHEDULE_PMTITEM *pstPidList,int iPidNum)
{
	CLock lock(&m_stLock);
	ScheduleServices::iterator it=m_CurrentService.find(wServiceID);
	if(it==m_CurrentService.end())
	{
		SchedulePidItems NewItem;
		m_CurrentService.insert(ScheduleServicesPair(wServiceID,NewItem));
		it=m_CurrentService.find(wServiceID);
	}
	if(it!=m_CurrentService.end())
	{
		SchedulePidItems &Pids=it->second;
		// NAāAf[^Rs[
		Pids.clear();
		Pids.insert(Pids.begin(),pstPidList,pstPidList+iPidNum);
		
		// \^撆ȂAtB^XV
		if(m_pScheduleRecord)
		{
			if(m_pScheduleRecord->pEnableService)
			{
				if(m_pScheduleRecord->pDenyPID) delete []m_pScheduleRecord->pDenyPID;
				m_pScheduleRecord->pDenyPID=NULL;
				m_pScheduleRecord->iDenyNum=0;
				GetDisablePids(FALSE,m_pScheduleRecord->pEnableService,m_pScheduleRecord->iEnableServiceNum,&m_pScheduleRecord->pDenyPID,&m_pScheduleRecord->iDenyNum);
				// tB^XV
				if(m_pScheduleRecord->pDenyPID)
				{
					if(m_lpSetFilterFunc)
					{
						m_lpSetFilterFunc(FALSE,m_pScheduleRecord->pEnableService,m_pScheduleRecord->iEnableServiceNum,m_pScheduleRecord->pDenyPID,m_pScheduleRecord->iDenyNum,m_lpSetFilterContext);
					}
				}
			}
		}
	}
}

// ݓ󂯎A^Jn^I
void CScheduleRec::PutCurrentTime(DateTime &stTime)
{
	m_stCurrentDateTime=stTime;
	PostMessage(m_hWnd,WM_SCHEDULE_PUT_TIME_AND_SEARCH,(WPARAM)stTime.Date,(LPARAM)stTime.Time);
}

// ^\w
BOOL CScheduleRec::PutScheduleByTime(WORD wServiceID,DateTime &stStart,DWORD dwRecTime,char *lpszName,int iChNo)
{
	// \ǉ
	if(OnScheduleAdd_ByDateTime(TRUE,wServiceID,&stStart,dwRecTime,lpszName,iChNo))
	{
		SetScheduleItem(&m_stEditItem);
		return TRUE;
	}
	return FALSE;
}

// ^\(Cxghcw)
BOOL CScheduleRec::PutScheduleByEventID(WORD wNetworkID,WORD wStreamID,WORD wServiceID,WORD wEventID,char *lpszName,int iChNo)
{
	if(OnScheduleAdd_ByEvent(wNetworkID,wStreamID,wServiceID,wEventID,lpszName,iChNo))
	{
		SetScheduleItem(&m_stEditItem);
		return TRUE;
	}
	return FALSE;
}

// ^悵Ă΁ARecorderɃpPbg𗬂
void CScheduleRec::PutStream(BYTE *pbyStream,DWORD dwLen)
{
	CLock lock(&m_stLock);
	if(m_bScheduleRecording)
	{
		if(m_pScheduleRecord)
		{
			if(m_pScheduleRecord->pFileRecord)
			{
				m_pScheduleRecord->pFileRecord->Write(pbyStream,dwLen);
			}
		}
	}
}


void CScheduleRec::UpdateEvent(DateTime &stCurrentTime)
{
	CLock lock(&m_stLock);

	// ^撆ŃCxgŵ̂₢킹
	if(m_pScheduleRecord)
	{
		if(m_pScheduleRecord->stItem.dwFlg&SCHEDULE_FLAG_EVENTID)
		{
			if(m_lpEpgRequestFunc)
			{
				struct TSEPG_PROGRAM stProg,stProgByTime;
				if(m_lpEpgRequestFunc(m_pScheduleRecord->stItem.stEvent.wNetworkID,m_pScheduleRecord->stItem.stEvent.wStreamID,m_pScheduleRecord->stItem.stEvent.wServiceID,m_pScheduleRecord->stItem.stEvent.wEventID,&stProg,m_lpEpgRequestContext))
				{
					if(m_pScheduleRecord->stItem.stEvent.byType!=stProg.byType || m_pScheduleRecord->stItem.stEvent.byVersion!=stProg.byVersion)
					{
						// XVꂽ
						m_pScheduleRecord->stItem.stEvent.byType=stProg.byType;
						m_pScheduleRecord->stItem.stEvent.byVersion=stProg.byVersion;
						// ԓKp
						m_pScheduleRecord->stItem.stTime.stStart=stProg.stStart;
						m_pScheduleRecord->stItem.stTime.dwRecSec=stProg.dwDuration;
						// ItZbgKp
						CDateTime::OffsetDateTime(m_pScheduleRecord->stItem.stTime.stStart,m_pScheduleRecord->stItem.stEvent.iOffsetStart*60);
						DateTimeVal64 dtVal = (DateTimeVal64)m_pScheduleRecord->stItem.stTime.dwRecSec-m_pScheduleRecord->stItem.stEvent.iOffsetStart*60+m_pScheduleRecord->stItem.stEvent.iOffsetEnd*60;
						if(dtVal<0)
						{
							m_pScheduleRecord->stItem.stTime.dwRecSec=0;
						} else {
							m_pScheduleRecord->stItem.stTime.dwRecSec=static_cast<DWORD>(dtVal);
						}
					}
					// ݂̃Cxg̏IԂ̏ꍇAݎł
					if(stProg.dwDuration==TimeVal_Unknown && m_lpEpgRequestFunc2)
					{
						if(m_lpEpgRequestFunc2(m_pScheduleRecord->stItem.stEvent.wServiceID,stCurrentTime,&stProgByTime,FALSE,m_lpEpgRequestContext))
						{
							if(stProg.wEventID!=stProgByTime.wEventID)
							{
								// CxgIDႤ(Cxg폜ꂽH)̂ŁA^~
								m_pScheduleRecord->stItem.stTime.dwRecSec=0;
							}
						}
					}
				} else {
					// CxgȂ(Cxg폜ꂽH)̂ŁA^~
					m_pScheduleRecord->stItem.stTime.dwRecSec=0;
				}
			}
		}
	}
	// ҋ@Xg̏
	for(unsigned int i=0;i<m_ScheduleList.size();i++)
	{
		bool bUpdateFlg=false;
		if(m_ScheduleList[i].dwFlg&SCHEDULE_FLAG_EVENTID)
		{
			if(m_lpEpgRequestFunc)
			{
				struct TSEPG_PROGRAM stProg;
				if(m_lpEpgRequestFunc(m_ScheduleList[i].stEvent.wNetworkID,m_ScheduleList[i].stEvent.wStreamID,m_ScheduleList[i].stEvent.wServiceID,m_ScheduleList[i].stEvent.wEventID,&stProg,m_lpEpgRequestContext))
				{
					if(m_ScheduleList[i].stEvent.byType!=stProg.byType || m_ScheduleList[i].stEvent.byVersion!=stProg.byVersion)
					{
						// XVꂽ
						m_ScheduleList[i].stEvent.byType=stProg.byType;
						m_ScheduleList[i].stEvent.byVersion=stProg.byVersion;
						lstrcpyn(m_ScheduleList[i].stEvent.szEventName,stProg.szTitle,TSEPG_EVENT_TITLE_MAX+1);
						// ԍXV
						m_ScheduleList[i].stTime.stStart=stProg.stStart;
						m_ScheduleList[i].stTime.dwRecSec=stProg.dwDuration;
						// ItZbgKp
						CDateTime::OffsetDateTime(m_ScheduleList[i].stTime.stStart,m_ScheduleList[i].stEvent.iOffsetStart*60);
						DateTimeVal64 dtVal = (DateTimeVal64)m_ScheduleList[i].stTime.dwRecSec-m_ScheduleList[i].stEvent.iOffsetStart*60+m_ScheduleList[i].stEvent.iOffsetEnd*60;
						if(dtVal<0)
						{
							m_ScheduleList[i].stTime.dwRecSec=0;
						} else {
							m_ScheduleList[i].stTime.dwRecSec=static_cast<DWORD>(dtVal);
						}
						bUpdateFlg=true;
					}
				}
			}
		}
		if(bUpdateFlg)
		{
			SetScheduleItem(&m_ScheduleList[i],i);
			break;
		}
	}
}

BOOL CScheduleRec::OnSchedulePreStart(struct ScheduleRecItem& stItem)
{
	CLock lock(&m_stLock);
	BOOL bRecStartError=FALSE;
#ifdef SCHEDULE_DEBUG_PRINT
	OutputDebugString("<<<<<<< Schedule Record PreStart >>>>>>>>\n");
#endif
	// `lI
	if(stItem.dwFlg&SCHEDULE_FLAG_CHANNEL)
	{
		if(m_pDTV->GetExtFunction()&DTV_EXTFUNC_CHSEL)
		{
			m_pDTV->SetChannel(stItem.byChannel);
		}
	}
	if(stItem.dwFlg&SCHEDULE_FLAG_CHANNEL_STR)
	{
		if(m_pDTV->GetExtFunction()&DTV_EXTFUNC_CHSTR)
		{
			m_pDTV->SetChannnelByString(stItem.szChannnelStr);
		}
	}

	// IuWFNg쐬
	m_pScheduleRecord = new ScheduleRecordingObj;					
	m_pScheduleRecord->stRecStart = stItem.stTime.stStart;
	CDateTime::OffsetDateTime(m_pScheduleRecord->stRecStart,-SCHEDULE_MARGIN_SEC);

	// ^擮쒆tO𗧂Ă
	stItem.dwFlg = (stItem.dwFlg & (SCHEDULE_FLAG_FULLBIT ^ SCHEDULE_FLAG_STATUSMASK)) | SCHEDULE_FLAG_PRERECORD;
	// f[^Rs[
	m_pScheduleRecord->stItem=stItem;
	m_bScheduleRecording = TRUE;
	// GUIACe
	PostMessage(m_hWnd,WM_SCHEDULE_REDRAWITEM,0,0);
	return TRUE;
}

BOOL CScheduleRec::OnScheduleStart(DateTime &stCurrentTime,struct ScheduleRecItem& stItem)
{
	CLock lock(&m_stLock);
	// CxgAAݎ̃Cxg擾āA
	BOOL bOldFlg=m_bCurrentProgram_EndTime_Unknown;
	m_bCurrentProgram_EndTime_Unknown = FALSE;
	if(stItem.dwFlg&SCHEDULE_FLAG_EVENTID)
	{
		if(stItem.dwFlg&SCHEDULE_FLAG_SERVICE_ID)
		{
			WORD wServiceID = atoi(stItem.szServiceID);
			struct TSEPG_PROGRAM stProg;
			if(m_lpEpgRequestFunc2(wServiceID,stCurrentTime,&stProg,FALSE,m_lpEpgRequestContext))
			{
				if(stProg.dwDuration==TimeVal_Unknown && CDateTime::Compare_Time(stProg.stStart,0,stItem.stTime.stStart,0)!=0)
				{
					// ݂̔ԑgIԖȂ̂ŊJnłȂ
#ifdef SCHEDULE_DEBUG_PRINT
					if(!bOldFlg)
					{
						OutputDebugString("<<<<<<< Schedule Record (Oԑg̏IȂ̂őҋ@) >>>>>>>>\n");
					}
#endif
					m_bCurrentProgram_EndTime_Unknown = TRUE;
					return FALSE;
				} else {
					if(bOldFlg)
					{
						// U^\ҋ@
						return FALSE;
					}
				}
			}
		}	
	}

#ifdef SCHEDULE_DEBUG_PRINT
	OutputDebugString("<<<<<<< Schedule Record Start >>>>>>>>\n");
#endif

	// T[rXtB^M
	if(m_lpSetFilterFunc)
	{
		if(stItem.dwFlg&SCHEDULE_FLAG_SERVICE_ID)
		{
			// ͒Pɐ擪̃T[rXIDLɂ邾Â\͂ŕON/OFF؂ւł邩EEE
			m_pScheduleRecord->pEnableService=new WORD[1];
			if(m_pScheduleRecord->pEnableService)
			{
				*m_pScheduleRecord->pEnableService=atoi(stItem.szServiceID);
				m_pScheduleRecord->iEnableServiceNum=1;
				GetDisablePids(FALSE,m_pScheduleRecord->pEnableService,m_pScheduleRecord->iEnableServiceNum,&m_pScheduleRecord->pDenyPID,&m_pScheduleRecord->iDenyNum);
				if(m_pScheduleRecord->pDenyPID)
				{
					if(m_lpSetFilterFunc)
					{
						m_lpSetFilterFunc(FALSE,m_pScheduleRecord->pEnableService,m_pScheduleRecord->iEnableServiceNum,m_pScheduleRecord->pDenyPID,m_pScheduleRecord->iDenyNum,m_lpSetFilterContext);
					}
				}
			}
		} else {
			m_lpSetFilterFunc(FALSE,NULL,0,NULL,0,m_lpSetFilterContext);
		}
	}

	// t@C
	char szFilePath[MAX_PATH]="";
	if(stItem.dwFlg & SCHEDULE_FLAG_USERFILENAME)
	{
		// t@Cw
		lstrcpy(szFilePath,stItem.szDir);
		PathAddBackslash(szFilePath);
		lstrcat(szFilePath,stItem.szFile);
		PathAddExtension(szFilePath,stItem.szExt);
	} else {
		// t@C
		lstrcpy(szFilePath,stItem.szDir);
		PathAddBackslash(szFilePath);
		long year,month,day,hour,min,sec;
		CDateTime::ConvertFrom_MJD(stItem.stTime.stStart.Date,year,month,day);
		CDateTime::ConvertFrom_TimeSec(stItem.stTime.stStart.Time,hour,min,sec);
		if(stItem.dwFlg & SCHEDULE_FLAG_EVENTID)
		{
			wsprintf(szFilePath+lstrlen(szFilePath),"%04d%02d%02d-%02d%02d-%s.ts",year,month,day,hour,min,stItem.stEvent.szEventName);
		} else {
            wsprintf(szFilePath+lstrlen(szFilePath),"%04d%02d%02d-%02d%02d.ts",year,month,day,hour,min);
		}
	}
	// ݂Ăt@CȂAԃt@C쐬
	CFileRecord::CheckExistAndRename(szFilePath);
#ifdef SCHEDULE_DEBUG_PRINT					
	OutputDebugString(szFilePath);
	OutputDebugString("\n");
#endif
	lstrcpy(m_pScheduleRecord->szRecPath,szFilePath);

	if(m_pScheduleRecord->stItem.bNoRecord)
	{
		// 쒆tO𗧂Ă
		stItem.dwFlg = (stItem.dwFlg & (SCHEDULE_FLAG_FULLBIT ^ SCHEDULE_FLAG_STATUSMASK)) | SCHEDULE_FLAG_VIEWING;
		// f[^Rs[
		m_pScheduleRecord->stItem=stItem;
		// GUIACe
		PostMessage(m_hWnd,WM_SCHEDULE_REDRAWITEM,0,0);
	} else {
		// t@CJ	
		m_pScheduleRecord->pFileRecord = new CFileRecord(FILE_WRITE_BLOCK_SIZE);
		if(!m_pScheduleRecord->pFileRecord->Open(m_pScheduleRecord->szRecPath))
		{
			// G[I
			RemoveScheduleItem(SCHEDULE_FLAG_REC_ERROR,0);
			// ^t@CIuWFNg폜
			if(m_pScheduleRecord) delete m_pScheduleRecord;
			m_pScheduleRecord = NULL;
			m_bScheduleRecording = FALSE;
		} else {
			// ^擮쒆tO𗧂Ă
			stItem.dwFlg = (stItem.dwFlg & (SCHEDULE_FLAG_FULLBIT ^ SCHEDULE_FLAG_STATUSMASK)) | SCHEDULE_FLAG_RECORDING;
			// f[^Rs[
			m_pScheduleRecord->stItem=stItem;
			// GUIACe
			PostMessage(m_hWnd,WM_SCHEDULE_REDRAWITEM,0,0);
		}
	}
	return TRUE;
}

BOOL CScheduleRec::OnScheduleEnd(struct ScheduleRecItem *pItem)
{
	CLock lock(&m_stLock);
	DWORD dwEndFlg=0;
#ifdef SCHEDULE_DEBUG_PRINT
	OutputDebugString("<<<<<<< Schedule Record END >>>>>>>>\n");
#endif
	// IuWFNg
	if(m_pScheduleRecord)
	{
		delete m_pScheduleRecord;
		m_pScheduleRecord = NULL;
	}
	m_bScheduleRecording = FALSE;
	// ItO𗧂Ă
	dwEndFlg=SCHEDULE_FLAG_REC_SUCCESS;
	// I
	RemoveScheduleItem(dwEndFlg,0);
	return TRUE;
}

// XPW[Ǝs
void CScheduleRec::Schedule(DateTime &stCurrentTime)
{
	CLock lock(&m_stLock);

	if(m_ScheduleList.size()>0)
	{
		UpdateEvent(stCurrentTime);

		// ԏɃ\[gĂ̂ŁA擪݂̂̂̔̂łnj
		struct ScheduleRecItem &stItem=m_ScheduleList[0];
		// IACe
		struct ScheduleRecItem *pItem=&stItem;
		if(m_pScheduleRecord)
		{
			// ^\^ҋ@΂D悵ďI
			pItem=&m_pScheduleRecord->stItem;
		}

		// I
		bool bEndFlg=false;
		if(!m_bCurrentProgram_EndTime_Unknown)
		{
			if(pItem->dwFlg&SCHEDULE_FLAG_DATETIME || (pItem->dwFlg&SCHEDULE_FLAG_EVENTID && pItem->stTime.stStart.Date>0))
			{
				if(pItem->stTime.dwRecSec!=TimeVal_Unknown)
				{
					DateTime stEnd=pItem->stTime.stStart;
					CDateTime::OffsetDateTime(stEnd,pItem->stTime.dwRecSec);			
					if(CDateTime::Compare_Time(stEnd,SCHEDULE_MARGIN_END_SEC,stCurrentTime,0)<0) bEndFlg=true;
				}
			}
		}
		if(bEndFlg)
		{
			if(m_bScheduleRecording && memcmp(&pItem->stTime.stStart,&stItem.stTime.stStart,sizeof(stItem.stTime.stStart))==0)
			{
				OnScheduleEnd(pItem);
			}
		} else {			
			// Jn
			BOOL bStartFlg=FALSE;
			if(stItem.dwFlg&SCHEDULE_FLAG_DATETIME || (stItem.dwFlg&SCHEDULE_FLAG_EVENTID && stItem.stTime.stStart.Date>0))
			{
				DateTime stStart=stItem.stTime.stStart;
				if(CDateTime::Compare_Time(stStart,-SCHEDULE_PREPROC_SEC,stCurrentTime,0)<0) bStartFlg=TRUE;
			}
			if(bStartFlg)
			{				
				if(!m_bScheduleRecording)
				{
					OnSchedulePreStart(stItem);
				}
			}
		}	
		if((stItem.dwFlg&SCHEDULE_FLAG_STATUSMASK)==SCHEDULE_FLAG_PRERECORD)
		{
			if(m_bScheduleRecording&&m_pScheduleRecord)
			{
				// sIς݂ŁA^Jn҂
				if(m_pScheduleRecord->pFileRecord==NULL)
				{
					if(m_pScheduleRecord->stItem.stTime.dwRecSec=0)
					{
						// 
						delete m_pScheduleRecord;
						m_pScheduleRecord = NULL;
						m_bScheduleRecording = FALSE;
					} else {
						if(CDateTime::Compare_Time(m_pScheduleRecord->stRecStart,0,stCurrentTime,0)<0)
						{
							if(!OnScheduleStart(stCurrentTime,stItem))
							{								
								if(!m_bCurrentProgram_EndTime_Unknown)
								{
									// 
									delete m_pScheduleRecord;
									m_pScheduleRecord = NULL;
									m_bScheduleRecording = FALSE;
								}								
							}
						}
					}
				}
			}
		}
	}
}